﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DailyPlanner
{
    /// <summary>
    /// Логика взаимодействия для CalendarPage.xaml
    /// </summary>
    public partial class CalendarPage : Page
    {
        int currentPage = DateTime.Today.Month;
        int itemsOnPage = 1;
        int maxPages = 0;
        public int UserID { get; set; }
        List<Month> Month = new List<Month>();
        public CalendarPage(int iduser)
        {
            InitializeComponent();
            UserID = iduser;
            DateTime dateTime = new DateTime(DateTime.Today.Year, 1,1);
            for(int i = 1; i <= 12; i++)
            {
                Month.Add(new Month { NameMonth = dateTime.ToString("MMMM", new CultureInfo("ru-RU")), NumberMonth = dateTime.Month });
                dateTime = dateTime.AddMonths(1);
                ShowMount();
            }
        }

        public void ShowDay()
        {
            List<Task> TaskofMonth = new List<Task>();
            int CurrentMonth = currentPage;
            DateTime dateofmonth = new DateTime(DateTime.Today.Year, CurrentMonth, 1);
            while(dateofmonth.Month == CurrentMonth)
            {
                Task FindTask = DB.db.Task.FirstOrDefault(item => item.IDUser == UserID && item.DateOfTask == dateofmonth);
                if(FindTask != null)
                {
                    TaskofMonth.Add(FindTask);
                }
                else
                {
                    TaskofMonth.Add(new Task { DateOfTask = dateofmonth });
                }
                dateofmonth = dateofmonth.AddDays(1);
            }
            DayOfMonthList.ItemsSource = TaskofMonth;
        }
        //Пагинация по списку месяцев
        public void ShowMount()
        {
            maxPages = (int)Math.Ceiling((decimal)Month.Count() / itemsOnPage);
            ListMonth.ItemsSource = Month.Skip((currentPage - 1) * itemsOnPage).Take(itemsOnPage).ToList();
            ShowDay();
        }

        private void TxtToLeft_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (currentPage > 1)
            {
                currentPage--;
            }
            else
            {
                currentPage = maxPages;
            }
            ShowMount();
        }

        private void TxtToRight_MouseDown(object sender, MouseButtonEventArgs e)
        {

            if (currentPage != maxPages)
            {
                currentPage++;

            }
            else if (currentPage == maxPages)
            {
                currentPage = 1;
            }
            ShowMount();
        }
    }
}
