﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DailyPlanner
{
    /// <summary>
    /// Логика взаимодействия для EditUserPage.xaml
    /// </summary>
    public partial class EditUserPage : Page
    {
        public int UserID { get; set; }
        //Переменная для хранения пути к изображению
        string FilePath = string.Empty;
        public EditUserPage(int iduser)
        {
            InitializeComponent();
            UserID = iduser;
            User SelectedUser = DB.db.User.SingleOrDefault(item => item.UserID == UserID);
            TxtName.Text = SelectedUser.RealName;
            TxtLogin.Text = SelectedUser.Login;
            UserAvatar.ItemsSource = DB.db.User.Where(item => item.UserID == UserID).ToList();
        }

        //Изменение изображения пользователя
        private void ImageGrid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            if (openFileDialog.ShowDialog() == true)
            {
                FilePath = openFileDialog.FileName;
                User user = DB.db.User.Find(UserID);
                if (FilePath != string.Empty)
                {
                    user.Photo = ConvertImageToByte.ImageToByte(FilePath);
                }
                DB.db.SaveChanges();
                UserAvatar.ItemsSource = DB.db.User.Where(item => item.UserID == UserID).ToList();
            }
            else
            {
                FilePath = string.Empty;
            }
        }
        //Функция редактирования пользователя
        public bool EditUser(string Name, string Login, string OldPassword, string NewPassword)
        {
            User user = DB.db.User.Find(UserID);
            if (ChangePassword.IsChecked == true)
            {
                if (Name == string.Empty || Login == string.Empty || OldPassword == string.Empty || NewPassword == string.Empty)
                {
                    MessageBox.Show("Ключевые поля не заполнены");
                    return false;
                }
                else
                {
                    if (DB.db.User.FirstOrDefault(item => item.UserID != UserID && item.Login.Contains(Login))!=null)
                    {
                        MessageBox.Show("Логин занят");
                        return false;
                    }
                    else if (OldPassword != user.Password)
                    {
                        MessageBox.Show("Неверно указан старый пароль");
                        return false;
                    }
                    else if (NewPassword.Length <= 8)
                    {
                        MessageBox.Show("Пароль слишком короткий");
                        return false;
                    }
                    else
                    {
                        user.RealName = Name;
                        user.Login = Login;
                        user.Password = NewPassword;
                        DB.db.SaveChanges();
                        MessageBox.Show("Изменено!");
                        return true;
                    }
                }
            }
            else
            {
                if (Name == string.Empty || Login == string.Empty)
                {
                    MessageBox.Show("Ключевые поля не заполнены");
                    return false;
                }
                else
                {
                    if (DB.db.User.Select(item => item.Login).Contains(Login))
                    {
                        MessageBox.Show("Логин занят");
                        return false;
                    }
                    else
                    {
                        user.RealName = Name;
                        user.Login = Login;
                        DB.db.SaveChanges();
                        return true;
                    }
                }
            }
        }

        private void BtnEditUser_Click(object sender, RoutedEventArgs e)
        {
            EditUser(TxtName.Text, TxtLogin.Text, PxbOldPassword.Password, PxbNewPassword.Password);
        }

        private void ChangePassword_Checked(object sender, RoutedEventArgs e)
        {
            PasswordStack.Visibility = Visibility.Visible;
        }

        private void ChangePassword_Unchecked(object sender, RoutedEventArgs e)
        {
            PasswordStack.Visibility = Visibility.Collapsed;
        }

        //Удаление фото пользователя
        private void BtnDeletePhoto_Click(object sender, RoutedEventArgs e)
        {
            User user = DB.db.User.Find(UserID);
            user.Photo = null;
            DB.db.SaveChanges();
            UserAvatar.ItemsSource = DB.db.User.Where(item => item.UserID == UserID).ToList();
        }
    }
}
