﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DailyPlanner
{
    /// <summary>
    /// Логика взаимодействия для PanelPage.xaml
    /// </summary>
    public partial class PanelPage : Page
    {
        //Меню выбора страниц
        public int UserID{ get; set; }
        public PanelPage(int iduser)
        {
            InitializeComponent();
            UserID = iduser;
            UserAvatar.ItemsSource = DB.db.User.Where(item => item.UserID == UserID).ToList();
        }

        private void BtnAddTask_Click(object sender, RoutedEventArgs e)
        {
            ManagerFrame.MainFrame.Navigate(new AddTaskPage(UserID));
        }

        private void BtnShowTask_Click(object sender, RoutedEventArgs e)
        {
            ManagerFrame.MainFrame.Navigate(new ShowTaskPage(UserID));
        }

        private void BtnShowCalendar_Click(object sender, RoutedEventArgs e)
        {
            ManagerFrame.MainFrame.Navigate(new CalendarPage(UserID));
        }

        private void BtnExit_Click(object sender, RoutedEventArgs e)
        {
            ManagerFrame.PanelFrame.Visibility = Visibility.Collapsed;
            while (ManagerFrame.MainFrame.CanGoBack)
            {
                ManagerFrame.MainFrame.GoBack();
            }
        }

        private void UserAvatar_MouseDown(object sender, MouseButtonEventArgs e)
        {
            ManagerFrame.PanelFrame.Navigate(new EditUserPanelPage(UserID));
            ManagerFrame.MainFrame.Navigate(new EditUserPage(UserID));
        }
    }
}
