﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DailyPlanner
{
    /// <summary>
    /// Логика взаимодействия для RegistrationPage.xaml
    /// </summary>
    public partial class RegistrationPage : Page
    {
        //Переменная для хранения пути к изображению
        string FilePath = string.Empty;
        public RegistrationPage()
        {
            InitializeComponent();
        }
        //Добавление изображения пользователя
        private void ImageGrid_MouseDown(object sender, MouseButtonEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            if (openFileDialog.ShowDialog() == true)
            {
                FilePath = openFileDialog.FileName;
                string uriString = $"{FilePath}";
                PhotoOfClent.Source = new BitmapImage(new Uri(@uriString));
            }
            else
            {
                FilePath = string.Empty;
            }
        }

        private void BtnRegistration_Click(object sender, RoutedEventArgs e)
        {
            RegistrationClient(TxtName.Text, TxtLogin.Text, PxbPassword.Password, FilePath);
        }

        //Регистрация пользователя
        public bool RegistrationClient(string Name, string Login, string Password,string FilePath)
        {
            if (Name == string.Empty || Login == string.Empty || Password == string.Empty)
            {
                MessageBox.Show("Ключевые поля не заполнены");
                return false;
            }
            else
            {
                if (DB.db.User.Select(item => item.Login).Contains(Login))
                {
                    MessageBox.Show("Логин занят");
                    return false;
                }
                else if (Password.Length<=8)
                {
                    MessageBox.Show("Пароль слишком короткий");
                    return false;
                }
                else
                {
                    try
                    {
                        User user = new User();
                        user.Login = Login;
                        user.Password = Password;
                        user.RealName = Name;
                        if(FilePath != string.Empty)
                        {
                            user.Photo = ConvertImageToByte.ImageToByte(FilePath);
                        }
                        DB.db.User.Add(user);
                        DB.db.SaveChanges();
                        MessageBox.Show("Вы зарегестрированы!");
                        return true;
                    }
                    catch
                    {
                        MessageBox.Show("Введено не корректное значение");
                        return false;
                    }
                }
            }
        }

        private void BtnDeletePhoto_Click(object sender, RoutedEventArgs e)
        {
            PhotoOfClent.Source = null;
            FilePath = string.Empty;
        }
    }
}
